#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include "gtkgui.h"

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include <gdk-pixbuf/gdk-pixbuf.h>

#include <stdlib.h>

//#include "import_v4l.h"
#include "import_v4lj.h"

void
on_load_image_open_clicked             (gpointer         user_data,
                                        GtkButton       *button)
{
	/*const gchar *filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (user_data));
	//g_print ("%s\n", filename);
	gtk_widget_destroy(GTK_WIDGET(user_data));
	GtkImage *image_input = GTK_IMAGE(lookup_widget(webc5, "image_input"));
	gtk_image_set_from_file(image_input, filename);*/
}

//char *filename, int width, int height, int bpp
char *filename = "data/webc2.ppm";
int height = 288;
int width  = 352;
int bpp    = 3;
int frames = 0, old_frames = 0;
time_t old_time = 0;
float fps  = 0;

// I COULD HOLD FIFTY FRAMES IN MY PANTS! But I'm only holding one.
char frame1[352*288*3];
char frame2[352*288*3];
char frame_diff_threshold[352*288*3];
char *curr_frame = frame1, *prev_frame = frame2, *tmp_frame = 0;
FILE *file = 0;

//transfer_t param;
//vob_t vob;

static GdkPixmap *in_pixmap  = NULL;
static GdkPixmap *out_pixmap = NULL;

void
on_load_image_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
	/*GtkWidget *filew;
	filew = create_load_image_dialog ();
	gtk_widget_show (filew);*/
	// "data/webc2.ppm", 352, 288, 3
	//G_PRIORITY_DEFAULT_IDLE
	
	GtkDrawingArea *input_image = GTK_DRAWING_AREA(lookup_widget(webc5, "input_image"));
	GtkDrawingArea *output_image = GTK_DRAWING_AREA(lookup_widget(webc5, "output_image"));
	in_pixmap = gdk_pixmap_new (GTK_WIDGET(input_image)->window,
							 width,
							 height,
							 -1);
	out_pixmap = gdk_pixmap_new (GTK_WIDGET(output_image)->window,
								width,
								height,
								-1);
	
	int a = import_v4lj_open(&file, width, height);
	//static int v4l_close(transfer_t *param);
	g_idle_add(webcam1, NULL);
	//webcam1();
}

void load_rc(gchar *site, gchar *user, gchar *type)
{
	// TODO: Make this support win32.
	FILE *rc = fopen("/home/jvoss/.rs/rsrc.txt", "r");
	if(rc == 0)
	{
		// No RC file, so give them the defaults.
		strcpy(site, "https://www.altsci.com/rs/");
		strcpy(user, "");
		strcpy(type, "Rubber Spoon");
		return;
	}
	else
	{
		// RC file, so give them their saved settings.
		// A proper rsrc.txt file looks like:
/*
https://www.altsci.com/rs/
joe_user
Rubber Spoon
*/
		fgets(site, 1024, rc);
		site[strlen(site) - 1] = 0;
		fgets(user, 256,  rc);
		user[strlen(user) - 1] = 0;
		fgets(type, 256,  rc);
		type[strlen(type) - 1] = 0;
		fclose(rc);
	}
}

void save_rc(const gchar *site, const gchar *user, const gchar *type)
{
	g_print ("%s, %s, %s.\n", site, user, type);
	// TODO: Make this support win32 and other users.
	struct stat buf;
	if(stat("/home/jvoss/.rs", &buf) != 0)
	{
		// Create the directory.
		if(mkdir("/home/jvoss/.rs", 0700) != 0)
		{
			g_print ("Error, resource file directory cannnot be created.\n");
			return;
		}
	}
	else
	{
		if(!S_ISDIR(buf.st_mode))
		{
			g_print ("Error, resource file directory is used.\n");
			return;
		}
	}
	FILE *rc = fopen("/home/jvoss/.rs/rsrc.txt", "w");
	if(rc == 0)
	{
		g_print ("Error, cannot save resource file.\n");
		return;
	}
	fputs(site, rc);
	fputs("\n", rc);
	fputs(user, rc);
	fputs("\n", rc);
	fputs(type, rc);
	fputs("\n", rc);
	fclose(rc);
}

void
on_settings_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *settings_dialog;
	settings_dialog = create_settings_dialog ();
	gtk_widget_show (settings_dialog);
	
	GtkEntry *settings_site = GTK_ENTRY(lookup_widget(settings_dialog, "settings_site"));
	GtkEntry *settings_user = GTK_ENTRY(lookup_widget(settings_dialog, "settings_user"));
	GtkEntry *settings_type = GTK_ENTRY(lookup_widget(settings_dialog, "settings_type"));
	gchar site[1024], user[256], type[256];
	load_rc(site, user, type);
	gtk_entry_set_text(settings_site, site);
	gtk_entry_set_text(settings_user, user);
	gtk_entry_set_text(settings_type, type);
}


void
on_upload_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *password_dialog;
	password_dialog = create_password_dialog ();
	gtk_widget_show (password_dialog);
}


void
on_settings_ok_clicked                 (gpointer         user_data,
                                        GtkButton       *button)
{
	// How do I get the data from 3+ text boxes?
	GtkWidget *settings_dialog = GTK_WIDGET(user_data);
	GtkEntry *settings_site = GTK_ENTRY(lookup_widget(settings_dialog, "settings_site"));
	GtkEntry *settings_user = GTK_ENTRY(lookup_widget(settings_dialog, "settings_user"));
	GtkEntry *settings_type = GTK_ENTRY(lookup_widget(settings_dialog, "settings_type"));
	const gchar *site = gtk_entry_get_text(settings_site);
	const gchar *user = gtk_entry_get_text(settings_user);
	const gchar *type = gtk_entry_get_text(settings_type);
	save_rc(site, user, type);

	gtk_widget_destroy(settings_dialog);
}


void
on_settings_cancel_clicked             (gpointer         user_data,
                                        GtkButton       *button)
{

	gtk_widget_destroy(GTK_WIDGET(user_data));
}


void free_out_data(guchar *pixels, gpointer data)
{
	g_free(pixels);
}

void
on_password_ok_clicked                 (gpointer         user_data,
                                        GtkButton       *button)
{
	/*GtkWidget *password_dialog = GTK_WIDGET(user_data);
	
	// Steg the image and load the preview.
	//g_print ("steg upload.\n");
	
	// The plan: 
	// 1) Take the data from g_input_image.
	GtkImage *image_input = GTK_IMAGE(lookup_widget(webc5, "image_input"));
	GdkPixbuf *pixbuf;
	pixbuf = gtk_image_get_pixbuf (image_input);
	
	// 2) Get the text to steg
	GtkTextView *message = GTK_TEXT_VIEW(lookup_widget(webc5, "message"));
	gchar *data;
	int data_length;
	GtkTextBuffer *message_buf = gtk_text_view_get_buffer (message);
	GtkTextIter start_iter, end_iter;
	gtk_text_buffer_get_start_iter (message_buf, &start_iter);
	gtk_text_buffer_get_end_iter (message_buf, &end_iter);
	data = gtk_text_buffer_get_text (message_buf, &start_iter, &end_iter, TRUE);
	data_length = strlen(data);
	
	// 3) Get a password.
	int key[50];
	
	GtkEntry *password_input = GTK_ENTRY(lookup_widget(password_dialog, "password_input"));
	const gchar *password = gtk_entry_get_text(password_input);
	
	// Secret Key
	StegKey(password, key);
	gtk_widget_destroy(password_dialog);
	
	// 4) Execute the steg function.
	guchar *pixels;
	int width, height, rowstride, n_channels, image_size;
	n_channels = gdk_pixbuf_get_n_channels (pixbuf);
	width = gdk_pixbuf_get_width (pixbuf);
	height = gdk_pixbuf_get_height (pixbuf);
	pixels = gdk_pixbuf_get_pixels (pixbuf);
	image_size = n_channels * width * height;
	
	guchar *out_data = g_new(guchar, image_size);

	//printf("%i, %s, %i, %08x, %i, %08x, %08x;\n", n_channels, data, data_length, key, 50, pixels, out_data);
	steg(data, data_length, key, 50, pixels, out_data);
	// Copy the data after real_data_length.
	// bytes_stegged = size * 8 bits * key[key_size - 1] per 50 bits
	int real_size = data_length * 8 * (key[49]+1) / 50;
	memcpy(out_data + real_size, pixels + real_size, image_size-real_size);
	
	// Output the file as ppm 24-bit.
	FILE *out_file = fopen("out.ppm", "wb");
	fprintf(out_file, "P6\n%i %i\n255\n", width, height);
	fwrite(out_data, image_size, 1, out_file);
	fclose(out_file);
	
	// 5) Draw it in the output.
	GtkImage *output_image = GTK_IMAGE(lookup_widget(webc5, "output_image"));
	GdkPixbuf *out_pixbuf = gdk_pixbuf_new_from_data(out_data, 
		GDK_COLORSPACE_RGB, FALSE, 8, width, height, width * n_channels, 
		free_out_data, NULL);
	gtk_image_set_from_pixbuf(output_image, out_pixbuf);
	
	GtkWidget *success_dialog;
	success_dialog = create_success_dialog ();
	gtk_widget_show (success_dialog);*/
}

void
on_password_cancel_clicked             (gpointer         user_data,
                                        GtkButton       *button)
{

	gtk_widget_destroy(GTK_WIDGET(user_data));
}


void
on_webc5_destroy                 (GtkObject       *object,
                                        gpointer         user_data)
{
	gtk_main_quit();
}



void
on_image_input_realize                 (GtkWidget       *widget,
                                        gpointer         user_data)
{
	g_print ("g_image_input is set.\n");

}


gboolean
on_output_image_button_press_event     (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
	// Steg the image and load the preview.
	g_print ("TODO: steg preview.\n");
	
	// The plan: 
	// 1) Take the data from g_input_image.
	GtkImage *image_input = GTK_IMAGE(lookup_widget(webc5, "input_image"));
	GdkPixmap *pixmap = NULL;
	GdkBitmap *mask = NULL;
	gtk_image_get_pixmap (image_input, &pixmap, &mask);
	
	// 2) Get the text to steg
	GtkTextView *message = GTK_TEXT_VIEW(lookup_widget(webc5, "message"));
	
	// 3) Get a password.
	GtkWidget *password_dialog;
	password_dialog = create_password_dialog ();
	gtk_widget_show (password_dialog);
	
	// 4) Execute the steg function.
	
	// 5) Draw it in the output.
	
	/*
	gdk_pixmap_create_from_data(GdkDrawable *drawable, 
		const gchar *data, gint width, gint height, gint depth, 
		const GdkColor *fg, const GdkColor *bg)
	gtk_image_set_from_pixmap (GtkImage *image, GdkPixmap *pixmap, GdkBitmap *mask)
	*/
	return FALSE;
}

int webcam1()
{
	/*char *filename = "data/webc2.ppm";
	int height = 288;
	int width  = 352;
	int bpp    = 3;
	int threshold = 50;
	if(argc > 1)
	{
		filename = argv[1];
	}
	if(argc > 2)
	{
		width = atoi(argv[2]);
	}
	if(argc > 3)
	{
		height = atoi(argv[3]);
	}
	if(argc > 4)
	{
		bpp = atoi(argv[4]);
	}
	if(argc > 5)
	{
		threshold = atoi(argv[5]);
	}*/
	int n_channels = bpp;
	int threshold = 50;
	//printf("Webcam PPM Parser\n");
	//printf("Reading %s (%ix%ix%i) repeatedly.\n", filename, width, height, bpp);
	char header[256];
	header[255] = 0;
	
	time_t new_time = time(0);
	if(new_time >= old_time+4)
	{
		fps = ((float)(frames - old_frames))/((float)(new_time - old_time));
		old_frames = frames;
		old_time = new_time;
	}
	printf("\rframes: %05i %2.2f fps", frames++, fps);
	fflush(stdout);
	
	int a = import_v4lj_decode(file, curr_frame);
	//while(1)
	{
		/*if(file == 0)  {
			printf("Opening %s.\n", filename);
			file = fopen(filename, "rb");
		}*/
		//while(!feof(file))
		{
			/*
			fgets(header, 255, file);
			if(feof(file)) return;
			//printf("1: %s", header);
			fgets(header, 255, file);
			//printf("2: %s", header);
			fgets(header, 255, file);
			//printf("3: %s", header);
			fread(curr_frame, width * height * bpp, 1, file);
			*/

			//GtkImage *input_image = GTK_IMAGE(lookup_widget(webc5, "image_input"));
			GtkDrawingArea *input_image = GTK_DRAWING_AREA(lookup_widget(webc5, "input_image"));
			GdkPixbuf *in_pixbuf = gdk_pixbuf_new_from_data(curr_frame, 
				GDK_COLORSPACE_RGB, FALSE, 8, width, height, width * n_channels, 
				free_out_data, NULL);
			//gtk_image_set_from_pixbuf(input_image, in_pixbuf);
			//gtk_widget_queue_draw(input_image);
			gdk_draw_pixbuf(in_pixmap, NULL, in_pixbuf, 0, 0, 0, 0, width, height, GDK_RGB_DITHER_NONE, 0, 0);
			gtk_widget_queue_draw(GTK_WIDGET(input_image));
			
			// Do the math here.
			// Skip the first frame because the diff not useful for the first frame.
			if(tmp_frame != 0)
			{
				d(curr_frame, prev_frame, frame_diff_threshold, width, height, bpp, threshold);
			}
			//GtkImage *output_image = GTK_IMAGE(lookup_widget(webc5, "output_image"));
			GtkDrawingArea *output_image = GTK_DRAWING_AREA(lookup_widget(webc5, "output_image"));
			GdkPixbuf *out_pixbuf = gdk_pixbuf_new_from_data(frame_diff_threshold, 
				GDK_COLORSPACE_RGB, FALSE, 8, width, height, width * 3, 
				free_out_data, NULL);
			//gtk_image_set_from_pixbuf(output_image, out_pixbuf);
			//gtk_widget_queue_draw(output_image);
			gdk_draw_pixbuf(out_pixmap, NULL, out_pixbuf, 0, 0, 0, 0, width, height, GDK_RGB_DITHER_NONE, 0, 0);
			gtk_widget_queue_draw(GTK_WIDGET(output_image));
			
			// Double buffer system, no strcpy necessary.
			tmp_frame = curr_frame;
			curr_frame = prev_frame;
			prev_frame = tmp_frame;
			//usleep(200000);
		}
		//fclose(file);
		return TRUE;
	}
	// Never actually gets here unless the while loop breaks.
	return FALSE;

}
#define AREA_ROWS_COLS 32
void d(char *curr_frame, char *prev_frame, char *output, int width, int height, int bpp, int threshold)
{
	int i;
	for(i = 0; i < width * height; i++)
	{
		int o = 
			(((curr_frame[3*i] - prev_frame[3*i]) > threshold) ||
			((curr_frame[3*i+1] - prev_frame[3*i+1]) > threshold) ||
			((curr_frame[3*i+2] - prev_frame[3*i+2]) > threshold));
		output[i*3] = o*255;
		output[i*3+1] = o*255;
		output[i*3+2] = o*255;
	}
	
	int areas[AREA_ROWS_COLS*AREA_ROWS_COLS];
	int row, col, x, y;
	int row_size = height/AREA_ROWS_COLS;
	int col_size = width/AREA_ROWS_COLS;
	int box_total, box_max = 0;
	for(row = 0; row < AREA_ROWS_COLS; row++)
	{
		for(col = 0; col < AREA_ROWS_COLS; col++)
		{
			box_total = 0;
			for(y = 0; y < row_size; y++)
			{
				for(x = 0; x < col_size; x++)
				{
					box_total += (output[3 * (row * row_size * width + col * col_size + y * width + x)] != 0);
				}
			}
			if(box_total > box_max) box_max = box_total;
			areas[row * AREA_ROWS_COLS + col] = box_total;
		}
	}
	//srand(33322);
	float red_div, green_div, blue_div, value;
	for(row = 0; row < AREA_ROWS_COLS; row++)
	{
		//printf("areas %2i: ", row);
		for(col = 0; col < AREA_ROWS_COLS; col++)
		{
			value     = 1;
			red_div   = 1;
			green_div = 1;
			blue_div  = 1;
			if(box_max * 0.6f > areas[row * AREA_ROWS_COLS + col]) //rand() > RAND_MAX / 2) //
			{
				value = 0.7f;
			}
			if(box_max * 0.9f < areas[row * AREA_ROWS_COLS + col])
			{
				blue_div  = 0.7f;
				red_div   = 0.7f;
			}
			if(box_max == areas[row * AREA_ROWS_COLS + col])
			{
				//printf("box_max found\n");
				blue_div  = 1;
				green_div = 0.7f;
				red_div   = 0.7f;
			}
			// erase output in this area
			for(y = 0; y < row_size; y++)
			{
				for(x = 0; x < col_size; x++)
				{
					// Woops, forgot that 255 is unsigned char.
					unsigned char *p = &(output[3 * (row * row_size * width + col * col_size + y * width + x)]);
					float c[3] = {p[0] * 1.0f, p[1] * 1.0f, p[2] * 1.0f};
					c[0] *= value * red_div;
					c[1] *= value * green_div;
					c[2] *= value * blue_div;
					//printf("%3.1f %3.1f %3.1f, ", c[0], c[1], c[2]);
					p[0] = (char)(c[0]);
					p[1] = (char)(c[1]);
					p[2] = (char)(c[2]);
					//printf("%3i %3i %3i\n", p[0], p[1], p[2]);
				}
			}
			//printf("%3i ", areas[row * 16 + col]);
		}
		//printf("\n");
	}
}

gboolean
on_input_image_expose_event            (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
	//printf("input_window exposed!\n");
	/*int n_channels = bpp;
	GdkPixbuf *in_pixbuf = gdk_pixbuf_new_from_data(curr_frame, 
	GDK_COLORSPACE_RGB, FALSE, 8, width, height, width * n_channels, 
	free_out_data, NULL);
	gdk_draw_pixbuf(input_window->window, NULL, in_pixbuf, 0, 0, 0, 0, width, height, GDK_RGB_DITHER_NONE, 0, 0);*/
	// This is required because gdk is STUPID!
	if(in_pixmap == NULL) return FALSE;
	gdk_draw_drawable (widget->window,
					   widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
					   in_pixmap,
					   event->area.x, event->area.y,
					   event->area.x, event->area.y,
					   event->area.width, event->area.height);
	/*gdk_draw_arc (widget->window,
				  widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
				  TRUE,
				  0, 0, widget->allocation.width, widget->allocation.height,
	0, 64 * 360);*/
	return FALSE;
}


gboolean
on_output_image_expose_event           (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
	//printf("output_window exposed!\n");
	/*int n_channels = bpp;
	GdkPixbuf *out_pixbuf = gdk_pixbuf_new_from_data(frame_diff_threshold, 
	GDK_COLORSPACE_RGB, FALSE, 8, width, height, width * 3, 
	free_out_data, NULL);
	gdk_draw_pixbuf(output_window->window, NULL, out_pixbuf, 0, 0, 0, 0, width, height, GDK_RGB_DITHER_NONE, 0, 0);*/
	if(out_pixmap == NULL) return FALSE;
	gdk_draw_drawable (widget->window,
					   widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
					   out_pixmap,
					   event->area.x, event->area.y,
					   event->area.x, event->area.y,
					   event->area.width, event->area.height);
	
	return FALSE;
}

