			if ((pRoot = cf_read (pConfig)) != NULL) {
        /*
				* get a pointer to the first section in the file.
		*/
				if ((pSection = cf_get_section (pRoot)) != NULL) {
					do {
            /*
						* get the default values for bright, contrast, hue and
						* saturation from the .xawtv file
			*/
						if (strncmp (pSection->name, "defaults", strlen (pSection->name)) == 0) {
              /*
							* get the default brightness value from .xawtv
			  */
							if ((pTemp = cf_get_named_key (pRoot, pSection->name, "bright")) != NULL) {

								char *percentsign;

								if ((percentsign = strstr (pTemp, "%")) == NULL) {
									bright = atoi (pTemp);
								}
								else {
									*percentsign = '\0';
									bright = (int) ((float) atoi (pTemp) * 655.36f);
									*percentsign = '%';
								}

							}

              /*
							* get the default contrast value from .xawtv
			  */
							if ((pTemp = cf_get_named_key (pRoot, pSection->name, "contrast")) != NULL) {

								char *percentsign;

								if ((percentsign = strstr (pTemp, "%")) == NULL) {
									contrast = atoi (pTemp);
								}
								else {
									*percentsign = '\0';
									contrast = (int) ((float) atoi (pTemp) * 655.36f);
									*percentsign = '%';
								}

							}

              /*
							* get the default color value from .xawtv
			  */
							if ((pTemp = cf_get_named_key (pRoot, pSection->name, "color")) != NULL) {

								char *percentsign;

								if ((percentsign = strstr (pTemp, "%")) == NULL) {
									color = atoi (pTemp);
								}
								else {
									*percentsign = '\0';
									color = (int) ((float) atoi (pTemp) * 655.36f);
									*percentsign = '%';
								}

							}

              /*
							* get the default hue value from .xawtv
			  */
							if ((pTemp = cf_get_named_key (pRoot, pSection->name, "hue")) != NULL) {

								char *percentsign;

								if ((percentsign = strstr (pTemp, "%")) == NULL) {
									hue = atoi (pTemp);
								}
								else {
									*percentsign = '\0';
									hue = (int) ((float) atoi (pTemp) * 655.36f);
									*percentsign = '%';
								}

							}

							if (!channel_has_tuner)
								break;
						}

						if (channel_has_tuner) {
              /*
							* get the freq table to use from the 'global' section.
			  */
							if (strncmp (pSection->name, "global", strlen (pSection->name)) == 0)
								if ((pTemp = cf_get_named_key (pRoot, pSection->name, "freqtab")) != NULL)
									snprintf (pNorm, TC_BUF_MIN - 1, "%s", pTemp);

              /*
							* is this section a channel?
			  */
							if ((pTemp = cf_get_named_key (pRoot, pSection->name, "channel")) != NULL) {
								snprintf (pChannel, 7, "%s", pTemp);
                /*
								* is this section our channel?
				*/
								if (station_id != NULL &&
															(strcmp (station_id, pSection->name) == 0 || strcmp (station_id, pChannel) == 0)) {

									if ((pTemp = cf_get_named_key (pRoot, pSection->name, "fine")) != NULL)
										fine = atoi (pTemp);

									i = 0;
									j = 1;
									channame = chanlist_names[i];
                  /*
									* scan the chanlist_names array looking for the freqtab.
				  */
									while (channame.name != NULL) {
										if (!strcmp (pNorm, channame.name)) {
											pChanlist = chanlists[i].list;
                      /*
											* scan the freqtab looking for the station.
					  */
											while (pChanlist->name != NULL) {
												if (!strcmp (pChannel, pChanlist->name)) {
													tfreq = (unsigned long) ((pChanlist->freq * .016 + fine));
													break;
												}
												pChanlist = chanlists[i].list + j++;
											}
											break;
										}
										channame = chanlist_names[++i];
									}

									found_station = 1;
															}
							}
							else if ((pTemp = cf_get_named_key (pRoot, pSection->name, "freq")) != NULL) {
								if (station_id != NULL && 
															(strcmp (station_id, pSection->name) == 0 || strcmp (station_id, pTemp) == 0)) {
                  /*
									* xawtv freq is in MHz
				  */
									tfreq = (unsigned long) (strtod (pTemp, NULL) * 16.0);
									found_station = 1;
															}
							}

							if (found_station) {
								snprintf (pStation, TC_BUF_MIN - 1, "%s", pSection->name);
								if ((pTemp = cf_get_named_key (pRoot, pSection->name, "bright")) != NULL) {
									bright = atoi (pTemp);
									if (strstr (pTemp, "%") != NULL) {
										bright *= 655.36f;
									}
								}
								if ((pTemp = cf_get_named_key (pRoot, pSection->name, "contrast")) != NULL) {
									contrast = atoi (pTemp);
									if (strstr (pTemp, "%") != NULL) {
										contrast *= 655.36f;
									}
								}
								if ((pTemp = cf_get_named_key (pRoot, pSection->name, "color")) != NULL) {
									color = atoi (pTemp);
									if (strstr (pTemp, "%") != NULL) {
										color *= 655.36f;
									}
								}
								if ((pTemp = cf_get_named_key (pRoot, pSection->name, "hue")) != NULL) {
									hue = atoi (pTemp);
									if (strstr (pTemp, "%") != NULL) {
										hue *= 655.36f;
									}
								}

								if (verb)
									printf ("(%s) \"%s\": using .xawtv from %s, freq=%.2fMHZ\n",
											__FILE__, pStation, pHome, (float) tfreq / 16.0);
								break;
							}
						}
					} while ((pSection = cf_get_next_section (pRoot, pSection)) != NULL);
				}
				if (channel_has_tuner && !found_station && station_id != NULL) {
					fprintf (stderr, "(%s) : Cannot find channel/name %s in .xawtv from %s\n", __FILE__, station_id, pHome);
					return -1;
				}
				CF_FREE_ROOT (pRoot);
				if (verb)
					printf ("(%s) %s: station=%s bright=%2.0f%s contrast=%2.0f%s color=%2.0f%s hue=%2.0f%s\n",
							__FILE__, pNorm, station_id == NULL ? "none" : station_id,
							(float) bright / 65535 * 100, "%", (float) contrast / 65535 * 100, "%",
							(float) color / 65535 * 100, "%", (float) hue / 65535 * 100, "%");
			}
